/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com). 
 * All Rights Reserved.
 * 
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it 
 * and/or modify it under the terms of the GNU Affero General Public License 
 * as published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with the Entangle ATSC 3.0 Base Stack. If not, see 
 * <https://www.gnu.org/licenses/>.
 */

#ifndef ENATSC3_H
#define ENATSC3_H

typedef enum
{
    ENATSC3Status_Success = 0,
    ENATSC3Status_Failure = 1,
    ENATSC3Status_OutOfRange = 2,
    ENATSC3Status_Dropped = 3,
    ENATSC3Status_NotSupported = 4,
    ENATSC3Status_InvalidData = 5,
    ENATSC3Status_NotFound = 6,
    ENATSC3Status_Retry = 7,
} ENATSC3Status;

typedef enum
{
    ENATSC3MediaType_Invalid = 0,
    ENATSC3MediaType_Audio = 1,
    ENATSC3MediaType_Video = 2,
    ENATSC3MediaType_Subtitle = 3,
} ENATSC3MediaType;

typedef enum
{
    ENATSC3Codec_Invalid = 0,

    // Video codecs
    ENATSC3Codec_HEV1 = 1,
    ENATSC3Codec_HVC1 = 2,

    // Audio codecs
    ENATSC3Codec_AAC = 32,
    ENATSC3Codec_AC4 = 33,

    // Subtitle codecs
    ENATSC3Codec_TTML = 64,
} ENATSC3Codec;

// Note that these enums come from A/331
typedef enum
{
    ENATSC3SLSProtocol_Reserved = 0,
    ENATSC3SLSProtocol_ROUTE = 1,
    ENATSC3SLSProtocol_MMTP = 2
} ENATSC3SLSProtocol;

#define NANOSECONDS_PER_SECOND  1000000000
#define MICROSECONDS_PER_SECOND 1000000
#define MILLISECONDS_PER_SECOND 1000
#define NANOSECONDS_PER_MILLISECOND (NANOSECONDS_PER_SECOND/MILLISECONDS_PER_SECOND)
#define NANOSECONDS_PER_MICROSECOND (NANOSECONDS_PER_SECOND/MICROSECONDS_PER_SECOND)
#define MICROSECONDS_PER_MILLISECOND (MICROSECONDS_PER_SECOND/MILLISECONDS_PER_SECOND)

#endif
