/*
 * Copyright © 2020-2022 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3BASEBANDRZRSDK2SOURCE_H
#define ENATSC3BASEBANDRZRSDK2SOURCE_H

typedef enum
{
    ENATSC3BasebandRZRSDK2SourceOperatingMode_Invalid = 0,
    ENATSC3BasebandRZRSDK2SourceOperatingMode_ATSC = 1,
    ENATSC3BasebandRZRSDK2SourceOperatingMode_ATSC3 = 2,
} ENATSC3BasebandRZRSDK2SourceOperatingMode;

ENATSC3Status
ENATSC3BasebandRZRSDK2SourceInitialize(int32_t *pNDevices);

ENATSC3Status
ENATSC3BasebandRZRSDK2SourceShutdown(void);

ENATSC3Status
ENATSC3BasebandRZRSDK2SourceOpen(int32_t deviceNumber, 
    ENATSC3BasebandRZRSDK2SourceOperatingMode operatingMode, 
    int32_t frequency, ENATSC3Source *ppSource);

ENATSC3Status
ENATSC3BasebandRZRSDK2SourceGetDeviceInfo(int32_t deviceNumber,
    char *pModel, int32_t nModelBytes, char *pSerial, int32_t nSerialBytes);

#endif
