/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com). 
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENATSC3ALP_H
#define LIBENATSC3ALP_H

typedef struct _ENATSC3ALPHandle_t *ENATSC3ALPHandle_t;

typedef void (*ENATSC3ALPIPV4CallbackFunction)(uint32_t plpId,
    struct timespec *pPacketTimeUTC, uint64_t packetNumber, 
    int32_t fError, int32_t fDiscontinuity, 
    const uint8_t *pPacket, int32_t sPacket, int32_t SID, void *pUserData);

typedef void (*ENATSC3ALPLinkLayerSignalingCallbackFunction)(uint32_t plpId,
    struct timespec *pPacketTimeUTC, uint64_t packetNumber, 
    int32_t fError, int32_t fDiscontinuity, 
    const uint8_t *pPacket, int32_t sPacket, void *pUserData);

ENATSC3Status
ENATSC3ALPOpen(ENATSC3ALPHandle_t *phATSC3ALP);

ENATSC3Status
ENATSC3ALPClose(ENATSC3ALPHandle_t hATSC3ALP);

ENATSC3Status
ENATSC3ALPRegisterCallbacks(ENATSC3ALPHandle_t hATSC3ALP,
    ENATSC3ALPIPV4CallbackFunction pIPV4Callback, 
    ENATSC3ALPLinkLayerSignalingCallbackFunction pLinkLayerSignalingCallback,
    void *pUserData);

ENATSC3Status
ENATSC3ALPSetPLPs(ENATSC3ALPHandle_t hATSC3ALP, uint64_t plpIdMask);

ENATSC3Status
ENATSC3ALPProcessALPPacket(ENATSC3ALPHandle_t hATSC3ALP, uint32_t plpId, 
    struct timespec *pPacketTimeUTC, uint64_t packetNumber, 
    int32_t fError, int32_t fDiscontinuity,
    const uint8_t *pPayload, int32_t payloadLength);

ENATSC3Status
ENATSC3ALPSetVerbosity(ENATSC3ALPHandle_t hATSC3ALP, 
    ENVerbosity verbosity);

void
ENATSC3ALPSetBitrateStatisticsEnabled(ENATSC3ALPHandle_t hATSC3ALP,
    int32_t fEnabled);

#endif
