/*
 * Copyright © 2020-2022 Koherence, LLC (www.koherence.com). 
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ATSC3ESG_SERVICEFRAGMENT_H
#define ATSC3ESG_SERVICEFRAGMENT_H

typedef struct
{
    EnXMLParserNodeBase base;

    char *pXML;
    int32_t sXML;

    uint32_t version;
    int32_t idXMLOffset;
    int32_t idXMLLen;
    int32_t globalServiceIDXMLOffset;
    int32_t globalServiceIDXMLLen;
} ATSC3ESGServiceFragmentNode;

#define ATSC3ESGServiceFragmentNodeAttribute_id                 0x0001
#define ATSC3ESGServiceFragmentNodeAttribute_version            0x0002
#define ATSC3ESGServiceFragmentNodeAttribute_globalServiceID    0x0004

typedef enum
{
    ATSC3ESGServiceFragmentNodeType_Invalid = 0,
    ATSC3ESGServiceFragmentNodeType_ServiceFragment = 1,
} ATSC3ESGServiceFragmentNodeType;

int32_t
ATSC3ESGServiceFragmentParse(const char *pXML, int32_t sXML,
    ATSC3ESGServiceFragmentNode *pParsedServiceFragment);

int32_t
ATSC3ESGServiceFragmentFree(
    ATSC3ESGServiceFragmentNode *pParsedServiceFragment);

#endif
