/*
 * Copyright © 2019-2022 Koherence, LLC (www.koherence.com). 
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3EOUTE_SLS_EFDT_H
#define ENATSC3EOUTE_SLS_EFDT_H


typedef struct
{
    EnXMLParserNodeBase base;

    int32_t contentLocationDataOffset;
    int32_t contentTypeDataOffset;
    uint32_t toi;
    uint32_t contentLength;
} ENATSC3ROUTESLSEFDTFileNode;

#define ENATSC3ROUTESLSEFDTFileNodeAttribute_contentLocation        0x00000001
#define ENATSC3ROUTESLSEFDTFileNodeAttribute_contentType            0x00000002
#define ENATSC3ROUTESLSEFDTFileNodeAttribute_contentLength          0x00000003
#define ENATSC3ROUTESLSEFDTFileNodeAttribute_toi                    0x00000004

typedef struct
{
    EnXMLParserNodeBase base;

    uint32_t expires;
    uint32_t efdtVersion;
    EnXMLParserDataOffsetArray files;   // array of ENATSC3ROUTESLSEFDTFileNode 
} ENATSC3ROUTESLSEFDTFDTInstanceNode;

#define ENATSC3ROUTESLSEFDTFDTInstanceNodeAttribute_expires         0x00000001
#define ENATSC3ROUTESLSEFDTFDTInstanceNodeAttribute_efdtVersion     0x00000002
#define ENATSC3ROUTESLSEFDTFDTInstanceChildNode_File                0x10000001

typedef struct
{
    EnXMLParserNodeBase base;

    ENATSC3ROUTESLSEFDTFDTInstanceNode fdtInstance;

    EnXMLParserDataBuffer dataBuffer;
} ENATSC3ROUTESLSEFDTNode;

#define ENATSC3ROUTESLSEFDTChildNode_FDTInstance                    0x10000001

typedef enum
{
    ENATSC3ROUTESLSEFDTNodeType_Invalid = 0,
    ENATSC3ROUTESLSEFDTNodeType_EFDT = 1,
    ENATSC3ROUTESLSEFDTNodeType_FDTInstance = 2,
    ENATSC3ROUTESLSEFDTNodeType_File = 3,
} ENATSC3ROUTESLSEFDTNodeType;

ENATSC3Status
ROUTESLSEFDTParse(const char *pXML, int32_t sXML, 
    ENATSC3ROUTESLSEFDTNode *pParsedEFDT);

ENATSC3Status
ROUTESLSEFDTFree(ENATSC3ROUTESLSEFDTNode *pParsedEFDT);

#endif
