/*
 * Copyright © 2018-2019 Koherence, LLC (www.koherence.com). 
 * All Rights Reserved.
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it 
 * and/or modify it under the terms of the GNU Affero General Public License 
 * as published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with the Entangle ATSC 3.0 Base Stack. If not, see 
 * <https://www.gnu.org/licenses/>.
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <arpa/inet.h>

#include "libenutils_defs.h"
#include "libenutils.h"

uint64_t
ENUtils_htonll(uint64_t x)
{
    uint64_t rval;

    if (htonl(1) == 1)
    {
        rval = x;
    }
    else
    {
        rval = (((uint64_t)htonl(x & 0xffffffff)) << 32) | htonl(x >> 32);
    }

    return rval;
}

uint64_t
ENUtils_ntohll(uint64_t x)
{
    uint64_t rval;

    if (ntohl(1) == 1)
    {
        rval = x;
    }
    else
    {
        rval = (((uint64_t)ntohl(x & 0xffffffff)) << 32) | ntohl(x >> 32);
    }

    return rval;
}

uint64_t
ENUtils_atoull(char *pString)
{
    uint64_t rval = 0;

    while (*pString)
    {
        rval *= 10;
        rval += *pString - '0';
        pString++;
    }

    return rval;
}
