/*
 * Copyright © 2018-2019 Koherence, LLC (www.koherence.com).
 * All Rights Reserved.
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it 
 * and/or modify it under the terms of the GNU Affero General Public License 
 * as published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with the Entangle ATSC 3.0 Base Stack. If not, see 
 * <https://www.gnu.org/licenses/>.
 */

#ifndef LIBENUTILS_CRASH_H
#define LIBENUTILS_CRASH_H

#define ENUtils_CrashAssert(X) \
{ \
    if (!(X)) \
    {    \
        ENUtils_CrashAssertInternal(__FILE__, __LINE__, #X, 0); \
    } \
}

#define ENUtils_CrashAssertImmediate(X) \
{ \
    if (!(X)) \
    {    \
        ENUtils_CrashAssertInternal(__FILE__, __LINE__, #X, 1); \
    } \
}

#define ENUtils_DebugAssert(X) \
{ \
    if (!(X)) \
    {    \
        ENUtils_DebugAssertInternal(__FILE__, __LINE__, #X, 0); \
    } \
}

#define ENUtils_DebugAssertImmediate(X) \
{ \
    if (!(X)) \
    {    \
        ENUtils_DebugAssertInternal(__FILE__, __LINE__, #X, 1); \
    } \
}

void
ENUtils_CrashAssertInternal(char *pFilename, int line, char *pReason, int32_t fImmediate);

void
ENUtils_DebugAssertInternal(char *pFilename, int line, char *pReason, int32_t fImmediate);

void
ENUtils_InstallSEGVHandler(void);

#endif
