/*
 * Copyright © 2018-2020 Koherence, LLC (www.koherence.com).
 * All Rights Reserved.
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it 
 * and/or modify it under the terms of the GNU Affero General Public License 
 * as published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with the Entangle ATSC 3.0 Base Stack. If not, see 
 * <https://www.gnu.org/licenses/>.
 */

#ifndef LIBENUTILS_DEFS_VERBOSITY_H
#define LIBENUTILS_DEFS_VERBOSITY_H

typedef enum
{
    // Errors only
    ENVerbosity_Error = 0,

    // Warnings
    ENVerbosity_Warn = 5,

    // Some debug output
    ENVerbosity_Terse = 10,

    // Debug output for stream events, such as start/end of a period
    ENVerbosity_StreamEventTrace = 15,

    // Debug output that occurs regularly, such as on a per-segment basis
    ENVerbosity_ObjectTrace = 20,

    // Debug output that occurs regularly, such as on a per-packet basis
    ENVerbosity_PacketTrace = 25,

    // Extremely verbose output
    ENVerbosity_Pedantic = 30,
} ENVerbosity;

#endif
